#!/bin/sh

. funx.sh

#check the args
unregisterFromSS=false;
removePrefsAndData=false;

for var in "$@"
do
	if /bin/test "$var" = "-unregisterFromSS"
	then
		unregisterFromSS=true;
	elif /bin/test "$var" = "-removePrefsAndData"
	then
		removePrefsAndData=true;
	fi
done


#unload launchd processes
#launchctl needs to run in root namespace
launchctlCmd="./NSTaskAsUserTool root /bin/launchctl"
enginePlist=/Library/LaunchDaemons/com.derman.syncem.engine.plist
if /bin/test ! -e "$enginePlist" 
then
	#if the plist is missing, copy in a new one so we can unload
	/bin/cp com.derman.syncem.engine.plist "$enginePlist"
	/bin/chmod 644 "$enginePlist" 
	/usr/sbin/chown root:wheel "$enginePlist"
fi
$launchctlCmd unload "$enginePlist" 

#need to find and unload all the users' com.derman.syncem.userlauncher.plist
for file in /Library/Application\ Support/SyncEm/pidsAndStatus/SyncEmUserLauncher_*.unload
do

	if /bin/test -e "$file"
	then
	   /bin/echo -n "unload" > "$file";
	fi
	
done
sleep 5;	#wait for unloads to complete

#quit/kill SyncEm Processes
killAllOfProcess "SyncEmSyncServicesTool";
killAllOfProcess "SyncEmMessageViewer.app";
killAllOfProcess "SyncEmConflictResolver.app";
killAllOfProcess "SyncEmUserLauncher.app";
killAllOfProcess "NSWorkspaceLauncherTool";
#killAllOfProcess "SyncEm.app";	#this also hits the uninstaller
killAllOfProcess "/SyncEm.app";	#add the / so we don't kill the uninstaller

#doesn't work under auth
#/usr/bin/osascript -e 'tell application "System Preferences" to quit'

#unregister with SyncServices
if $unregisterFromSS
then
	if /bin/test -e "/Library/Application Support/SyncEm/SyncEmSyncServicesTool"
	then
		"/Library/Application Support/SyncEm/SyncEmSyncServicesTool" unregister
	else
		if /bin/test -e UnregisterSyncEmSS
		then
			#fail over if SyncEmSyncServicesTool has already been removed
			./UnregisterSyncEmSS
		fi
	fi
fi

#remove the files
pushd "/Library/Application Support/SyncEm"
	#leave data and videos directories
	/bin/rm -rf "pidsAndStatus" *.app *.menu *.framework *.syncschema
	/bin/rm * 2>&1 > /dev/null
popd
if $removePrefsAndData
then
	/bin/rm -rf "/Library/Application Support/SyncEm"
fi
/bin/rm -rf "/Library/PreferencePanes/SyncEmPrefPane.prefPane"
/bin/rm -rf "/Library/LaunchDaemons/com.derman.syncem.engine.plist"
/bin/rm -rf ~/Library/Preferences/com.derman.SyncEm.*.plist

#need to find and delete all the users' "~/Library/Application Support/SyncEm"
/bin/rm -rf /Users/*/Library/Application\ Support/SyncEm

#need to find and delete all the users' "com.derman.syncem.userlauncher.plist"
/bin/rm -rf /Users/*/Library/LaunchAgents/com.derman.syncem.userlauncher.plist

#last remove the receipt
/bin/rm -rf /Library/Receipts/SyncEm*.*.pkg

#reload menu extra
killAllOfProcess "/System/Library/CoreServices/SystemUIServer.app/Contents/MacOS/SystemUIServer";

#if the SyncEmEngineLaunchdTool or Engine is still running, kill it now
killAllOfProcess "SyncEmEngineLoopTool";
killAllOfProcess "/SyncEmEngine.app";
killAllOfProcess "SyncEmEngineLaunchdTool";

#uninstall Mail.scpt from iCal
#10.5 and later they are in the Scripts directory
iCalScriptsDir=/Applications/iCal.app/Contents/Resources/Scripts
if /bin/test ! -d $iCalScriptsDir
then
	#10.4
	iCalScriptsDir=/Applications/iCal.app/Contents/Resources
fi

#backup old Mail.scpt file if no backup yet
if /bin/test -e $iCalScriptsDir/Mail_SyncEm_Backup.scpt
then
	rm $iCalScriptsDir/Mail.scpt
	mv $iCalScriptsDir/Mail_SyncEm_Backup.scpt $iCalScriptsDir/Mail.scpt
fi


#remove user and group
#syncEmUserName="_syncem";
#syncEmGroupName="$syncEmUserName";
#
#dsclCmd="/usr/bin/dscl /Local/Default/";
#
#$dsclCmd -delete /Users/$syncEmUserName
#$dsclCmd -delete /Groups/$syncEmGroupName
